diff -uNr openmp-3.5.0.src/runtime/src/kmp_runtime.c openmp-3.5.0.src.r219214/runtime/src/kmp_runtime.c
--- openmp-3.5.0.src/runtime/src/kmp_runtime.c	2014-08-07 07:16:59.000000000 -0400
+++ openmp-3.5.0.src.r219214/runtime/src/kmp_runtime.c	2014-10-24 19:58:41.000000000 -0400
@@ -5668,9 +4530,8 @@
             __kmp_partition_places( team );
 # endif
 #endif
-
         }
-        else if ( team -> t.t_nproc < new_nproc ) {
+        else { // team->t.t_nproc < new_nproc
 #if KMP_OS_LINUX && KMP_AFFINITY_SUPPORTED
             kmp_affin_mask_t *old_mask;
             if ( KMP_AFFINITY_CAPABLE() ) {
@@ -5681,21 +4542,39 @@
             KA_TRACE( 20, ("__kmp_allocate_team: increasing hot team thread count to %d\n", new_nproc ));
 
 #if KMP_MIC
-            team -> t.t_size_changed = 1;
+            team->t.t_size_changed = 1;
 #endif
 
 
-            if(team -> t.t_max_nproc < new_nproc) {
+#if KMP_NESTED_HOT_TEAMS
+            int avail_threads = hot_teams[level].hot_team_nth;
+            if( new_nproc < avail_threads )
+                avail_threads = new_nproc;
+            kmp_info_t **other_threads = team->t.t_threads;
+            for ( f = team->t.t_nproc; f < avail_threads; ++f ) {
+                // Adjust barrier data of reserved threads (if any) of the team
+                // Other data will be set in __kmp_initialize_info() below.
+                int b;
+                kmp_balign_t * balign = other_threads[f]->th.th_bar;
+                for ( b = 0; b < bs_last_barrier; ++ b ) {
+                    balign[b].bb.b_arrived = team->t.t_bar[b].b_arrived;
+                    KMP_DEBUG_ASSERT(balign[b].bb.wait_flag != KMP_BARRIER_PARENT_FLAG);
+                }
+            }
+            if( hot_teams[level].hot_team_nth >= new_nproc ) {
+                // we have all needed threads in reserve, no need to allocate any
+                // this only possible in mode 1, cannot have reserved threads in mode 0
+                KMP_DEBUG_ASSERT(__kmp_hot_teams_mode == 1);
+                team->t.t_nproc = new_nproc;                     // just get reserved threads involved
+            } else {
+                // we may have some threads in reserve, but not enough
+                team->t.t_nproc = hot_teams[level].hot_team_nth; // get reserved threads involved if any
+                hot_teams[level].hot_team_nth = new_nproc;       // adjust hot team max size
+#endif // KMP_NESTED_HOT_TEAMS
+            if(team->t.t_max_nproc < new_nproc) {
                 /* reallocate larger arrays */
                 __kmp_reallocate_team_arrays(team, new_nproc);
-                __kmp_reinitialize_team( team,
-#if OMP_30_ENABLED
-                                         new_icvs, NULL
-#else
-                                         new_set_nproc, new_set_dynamic, new_set_nested,
-                                         new_set_blocktime, new_bt_intervals, new_bt_set
-#endif // OMP_30_ENABLED
-                                         );
+                __kmp_reinitialize_team( team, new_icvs, NULL );
             }
 
 #if KMP_OS_LINUX && KMP_AFFINITY_SUPPORTED
@@ -5723,8 +4602,9 @@
                 { // Initialize barrier data for new threads.
                     int b;
                     kmp_balign_t * balign = new_worker->th.th_bar;
-                    for ( b = 0; b < bp_last_bar; ++ b ) {
+                    for( b = 0; b < bs_last_barrier; ++ b ) {
                         balign[ b ].bb.b_arrived        = team->t.t_bar[ b ].b_arrived;
+                        KMP_DEBUG_ASSERT(balign[b].bb.wait_flag != KMP_BARRIER_PARENT_FLAG);
                     }
                 }
             }
@@ -5736,19 +4616,12 @@
                 KMP_CPU_FREE(old_mask);
             }
 #endif
-
+#if KMP_NESTED_HOT_TEAMS
+            } // end of check of t_nproc vs. new_nproc vs. hot_team_nth
+#endif // KMP_NESTED_HOT_TEAMS
             /* make sure everyone is syncronized */
-            __kmp_initialize_team( team, new_nproc,
-#if OMP_30_ENABLED
-              new_icvs,
-              root->r.r_uber_thread->th.th_ident
-#else
-              new_set_nproc, new_set_dynamic, new_set_nested,
-              new_set_blocktime, new_bt_intervals, new_bt_set
-#endif
-            );
+            __kmp_initialize_team( team, new_nproc, new_icvs, root->r.r_uber_thread->th.th_ident );
 
-#if OMP_30_ENABLED
             if ( __kmp_tasking_mode != tskm_immediate_exec ) {
                 kmp_task_team_t *task_team = team->t.t_task_team;
                 if ( task_team != NULL ) {
@@ -5758,7 +4631,6 @@
                     task_team->tt.tt_ref_ct = new_nproc - 1;
                 }
             }
-#endif
 
             /* reinitialize the old threads */
             for( f = 0  ;  f < team->t.t_nproc  ;  f++ )
@@ -5777,62 +4649,39 @@
             __kmp_partition_places( team );
 # endif
 #endif
-
-        }
-        else {
-            KA_TRACE( 20, ("__kmp_allocate_team: reusing hot team\n" ));
-#if KMP_MIC
-            // This case can mean that omp_set_num_threads() was called and the hot team size
-            // was already reduced, so we check the special flag
-            if ( team -> t.t_size_changed == -1 ) {
-                team -> t.t_size_changed = 1;
-            } else {
-                team -> t.t_size_changed = 0;
-            }
-#endif
-
-#if OMP_30_ENABLED
-            // TODO???: team -> t.t_max_active_levels = new_max_active_levels;
-            team -> t.t_sched =  new_icvs->sched;
-#endif
-
-            __kmp_reinitialize_team( team,
-#if OMP_30_ENABLED
-                                     new_icvs, root->r.r_uber_thread->th.th_ident
-#else
-                                     new_set_nproc, new_set_dynamic, new_set_nested,
-                                     new_set_blocktime, new_bt_intervals, new_bt_set
-#endif // OMP_30_ENABLED
-                                     );
-
-#if OMP_30_ENABLED
-            KF_TRACE( 10, ("__kmp_allocate_team2: T#%d, this_thread=%p team=%p\n",
-                           0, team->t.t_threads[0], team ) );
-            __kmp_push_current_task_to_thread( team -> t.t_threads[ 0 ], team, 0 );
-#endif
+        } // Check changes in number of threads
 
 #if OMP_40_ENABLED
-# if KMP_AFFINITY_SUPPORTED
-            if ( team->t.t_proc_bind == new_proc_bind ) {
-                KA_TRACE( 200, ("__kmp_allocate_team: reusing hot team #%d bindings: proc_bind = %d, partition = [%d,%d]\n",
-                  team->t.t_id, new_proc_bind, team->t.t_first_place,
-                  team->t.t_last_place ) );
-            }
-            else {
-                team->t.t_proc_bind = new_proc_bind;
-                __kmp_partition_places( team );
-            }
-# else
-            if ( team->t.t_proc_bind != new_proc_bind ) {
-                team->t.t_proc_bind = new_proc_bind;
+        kmp_info_t *master = team->t.t_threads[0];
+        if( master->th.th_teams_microtask ) {
+            for( f = 1; f < new_nproc; ++f ) {
+                // propagate teams construct specific info to workers
+                kmp_info_t *thr = team->t.t_threads[f];
+                thr->th.th_teams_microtask = master->th.th_teams_microtask;
+                thr->th.th_teams_level     = master->th.th_teams_level;
+                thr->th.th_teams_size      = master->th.th_teams_size;
             }
-# endif /* KMP_AFFINITY_SUPPORTED */
+        }
 #endif /* OMP_40_ENABLED */
+#if KMP_NESTED_HOT_TEAMS
+        if( level ) {
+            // Sync task (TODO: and barrier?) state for nested hot teams, not needed for outermost hot team.
+            for( f = 1; f < new_nproc; ++f ) {
+                kmp_info_t *thr = team->t.t_threads[f];
+                thr->th.th_task_state = master->th.th_task_state;
+                int b;
+                kmp_balign_t * balign = thr->th.th_bar;
+                for( b = 0; b < bs_last_barrier; ++ b ) {
+                    balign[ b ].bb.b_arrived        = team->t.t_bar[ b ].b_arrived;
+                    KMP_DEBUG_ASSERT(balign[b].bb.wait_flag != KMP_BARRIER_PARENT_FLAG);
+                }
+            }
         }
+#endif // KMP_NESTED_HOT_TEAMS
 
         /* reallocate space for arguments if necessary */
         __kmp_alloc_argv_entries( argc, team, TRUE );
-        team -> t.t_argc     = argc;
+        team->t.t_argc     = argc;
         //
         // The hot team re-uses the previous task team,
         // if untouched during the previous release->gather phase.
@@ -5840,10 +4689,10 @@
 
         KF_TRACE( 10, ( " hot_team = %p\n", team ) );
 
-#if OMP_30_ENABLED && KMP_DEBUG
+#if KMP_DEBUG
         if ( __kmp_tasking_mode != tskm_immediate_exec ) {
             KA_TRACE( 20, ("__kmp_allocate_team: hot team task_team = %p after reinit\n",
-              team -> t.t_task_team ));
+              team->t.t_task_team ));
         }
 #endif
 
@@ -5862,25 +4711,15 @@
             __kmp_team_pool = team->t.t_next_pool;
 
             /* setup the team for fresh use */
-            __kmp_initialize_team( team, new_nproc,
-#if OMP_30_ENABLED
-              new_icvs,
-              NULL // TODO: !!!
-#else
-              new_set_nproc, new_set_dynamic, new_set_nested,
-              new_set_blocktime, new_bt_intervals, new_bt_set
-#endif
-            );
+            __kmp_initialize_team( team, new_nproc, new_icvs, NULL );
 
-#if OMP_30_ENABLED
             KA_TRACE( 20, ( "__kmp_allocate_team: setting task_team %p to NULL\n",
                             &team->t.t_task_team ) );
-            team -> t.t_task_team = NULL;
-#endif
+            team->t.t_task_team = NULL;
 
             /* reallocate space for arguments if necessary */
             __kmp_alloc_argv_entries( argc, team, TRUE );
-            team -> t.t_argc     = argc;
+            team->t.t_argc     = argc;
 
             KA_TRACE( 20, ("__kmp_allocate_team: team %d init arrived: join=%u, plain=%u\n",
                             team->t.t_id, KMP_INIT_BARRIER_STATE, KMP_INIT_BARRIER_STATE ));
@@ -5913,28 +4752,18 @@
     team = (kmp_team_t*) __kmp_allocate( sizeof( kmp_team_t ) );
 
     /* and set it up */
-    team -> t.t_max_nproc   = max_nproc;
+    team->t.t_max_nproc   = max_nproc;
     /* NOTE well, for some reason allocating one big buffer and dividing it
      * up seems to really hurt performance a lot on the P4, so, let's not use
      * this... */
     __kmp_allocate_team_arrays( team, max_nproc );
 
     KA_TRACE( 20, ( "__kmp_allocate_team: making a new team\n" ) );
-    __kmp_initialize_team( team, new_nproc,
-#if OMP_30_ENABLED
-      new_icvs,
-      NULL // TODO: !!!
-#else
-      new_set_nproc, new_set_dynamic, new_set_nested,
-      new_set_blocktime, new_bt_intervals, new_bt_set
-#endif
-    );
+    __kmp_initialize_team( team, new_nproc, new_icvs, NULL );
 
-#if OMP_30_ENABLED
     KA_TRACE( 20, ( "__kmp_allocate_team: setting task_team %p to NULL\n",
                     &team->t.t_task_team ) );
-    team -> t.t_task_team = NULL;    // to be removed, as __kmp_allocate zeroes memory, no need to duplicate
-#endif
+    team->t.t_task_team = NULL;    // to be removed, as __kmp_allocate zeroes memory, no need to duplicate
 
     if ( __kmp_storage_map ) {
         __kmp_print_team_storage_map( "team", team, team->t.t_id, new_nproc );
@@ -5942,7 +4771,7 @@
 
     /* allocate space for arguments */
     __kmp_alloc_argv_entries( argc, team, FALSE );
-    team -> t.t_argc        = argc;
+    team->t.t_argc        = argc;
 
     KA_TRACE( 20, ("__kmp_allocate_team: team %d init arrived: join=%u, plain=%u\n",
                     team->t.t_id, KMP_INIT_BARRIER_STATE, KMP_INIT_BARRIER_STATE ));
@@ -5970,7 +4799,7 @@
 /* free the team.  return it to the team pool.  release all the threads
  * associated with it */
 void
-__kmp_free_team( kmp_root_t *root, kmp_team_t *team )
+__kmp_free_team( kmp_root_t *root, kmp_team_t *team  USE_NESTED_HOT_ARG(kmp_info_t *master) )
 {
     int f;
     KA_TRACE( 20, ("__kmp_free_team: T#%d freeing team %d\n", __kmp_get_gtid(), team->t.t_id ));
@@ -5981,15 +4810,37 @@
     KMP_DEBUG_ASSERT( team->t.t_nproc <= team->t.t_max_nproc );
     KMP_DEBUG_ASSERT( team->t.t_threads );
 
+    int use_hot_team = team == root->r.r_hot_team;
+#if KMP_NESTED_HOT_TEAMS
+    int level;
+    kmp_hot_team_ptr_t *hot_teams;
+    if( master ) {
+        level = team->t.t_active_level - 1;
+        if( master->th.th_teams_microtask ) {                         // in teams construct?
+            if( master->th.th_teams_size.nteams > 1 ) {
+               ++level; // level was not increased in teams construct for team_of_masters
+            }
+            if( team->t.t_pkfn != (microtask_t)__kmp_teams_master &&
+                master->th.th_teams_level == team->t.t_level ) {
+                ++level; // level was not increased in teams construct for team_of_workers before the parallel
+            }            // team->t.t_level will be increased inside parallel
+        }
+        hot_teams = master->th.th_hot_teams;
+        if( level < __kmp_hot_teams_max_level ) {
+            KMP_DEBUG_ASSERT( team == hot_teams[level].hot_team );
+            use_hot_team = 1;
+        }
+    }
+#endif // KMP_NESTED_HOT_TEAMS
+
     /* team is done working */
     TCW_SYNC_PTR(team->t.t_pkfn, NULL); // Important for Debugging Support Library.
-    team -> t.t_copyin_counter = 0; // init counter for possible reuse
+    team->t.t_copyin_counter = 0; // init counter for possible reuse
     // Do not reset pointer to parent team to NULL for hot teams.
 
-    /* if we are a nested team, release our threads */
-    if( team != root->r.r_hot_team ) {
+    /* if we are non-hot team, release our threads */
+    if( ! use_hot_team ) {
 
-#if OMP_30_ENABLED
         if ( __kmp_tasking_mode != tskm_immediate_exec ) {
             kmp_task_team_t *task_team = team->t.t_task_team;
             if ( task_team != NULL ) {
@@ -6007,10 +4858,9 @@
                 team->t.t_task_team = NULL;
             }
         }
-#endif /* OMP_30_ENABLED */
 
         // Reset pointer to parent team only for non-hot teams.
-        team -> t.t_parent = NULL;
+        team->t.t_parent = NULL;
 
 
         /* free the worker threads */
@@ -6023,7 +4873,7 @@
 
         /* put the team back in the team pool */
         /* TODO limit size of team pool, call reap_team if pool too large */
-        team -> t.t_next_pool  = (kmp_team_t*) __kmp_team_pool;
+        team->t.t_next_pool  = (kmp_team_t*) __kmp_team_pool;
         __kmp_team_pool        = (volatile kmp_team_t*) team;
     }
 
@@ -6035,29 +4885,21 @@
 kmp_team_t *
 __kmp_reap_team( kmp_team_t *team )
 {
-    kmp_team_t *next_pool = team -> t.t_next_pool;
+    kmp_team_t *next_pool = team->t.t_next_pool;
 
     KMP_DEBUG_ASSERT( team );
-    KMP_DEBUG_ASSERT( team -> t.t_dispatch    );
-    KMP_DEBUG_ASSERT( team -> t.t_disp_buffer );
-    KMP_DEBUG_ASSERT( team -> t.t_threads     );
-    #if OMP_30_ENABLED
-    #else
-    KMP_DEBUG_ASSERT( team -> t.t_set_nproc   );
-    #endif
-    KMP_DEBUG_ASSERT( team -> t.t_argv        );
+    KMP_DEBUG_ASSERT( team->t.t_dispatch    );
+    KMP_DEBUG_ASSERT( team->t.t_disp_buffer );
+    KMP_DEBUG_ASSERT( team->t.t_threads     );
+    KMP_DEBUG_ASSERT( team->t.t_argv        );
 
     /* TODO clean the threads that are a part of this? */
 
     /* free stuff */
 
     __kmp_free_team_arrays( team );
-#if (KMP_PERF_V106 == KMP_ON)
-    if ( team -> t.t_argv != &team -> t.t_inline_argv[0] )
-        __kmp_free( (void*) team -> t.t_argv );
-#else
-    __kmp_free( (void*) team -> t.t_argv );
-#endif
+    if ( team->t.t_argv != &team->t.t_inline_argv[0] )
+        __kmp_free( (void*) team->t.t_argv );
     __kmp_free( team );
 
     KMP_MB();
@@ -6102,6 +4944,15 @@
 
     KMP_DEBUG_ASSERT( this_th );
 
+    // When moving thread to pool, switch thread to wait on own b_go flag, and uninitialized (NULL team).
+    int b;
+    kmp_balign_t *balign = this_th->th.th_bar;
+    for (b=0; b<bs_last_barrier; ++b) {
+        if (balign[b].bb.wait_flag == KMP_BARRIER_PARENT_FLAG)
+            balign[b].bb.wait_flag = KMP_BARRIER_SWITCH_TO_OWN_FLAG;
+        balign[b].bb.team = NULL;
+    }
+
 
     /* put thread back on the free pool */
     TCW_PTR(this_th->th.th_team, NULL);
@@ -6164,362 +5015,8 @@
     KMP_MB();
 }
 
-void
-__kmp_join_barrier( int gtid )
-{
-    register kmp_info_t   *this_thr       = __kmp_threads[ gtid ];
-    register kmp_team_t   *team;
-    register kmp_uint      nproc;
-    kmp_info_t            *master_thread;
-    int                    tid;
-    #ifdef KMP_DEBUG
-        int                    team_id;
-    #endif /* KMP_DEBUG */
-#if USE_ITT_BUILD
-    void * itt_sync_obj = NULL;
-    #if USE_ITT_NOTIFY
-        if ( __itt_sync_create_ptr || KMP_ITT_DEBUG ) // don't call routine without need
-            itt_sync_obj = __kmp_itt_barrier_object( gtid, bs_forkjoin_barrier ); // get object created at fork_barrier
-    #endif
-#endif /* USE_ITT_BUILD */
-
-    KMP_MB();
-
-    /* get current info */
-    team          = this_thr -> th.th_team;
-    /*    nproc         = team -> t.t_nproc;*/
-    nproc         = this_thr -> th.th_team_nproc;
-    KMP_DEBUG_ASSERT( nproc == team->t.t_nproc );
-    tid           = __kmp_tid_from_gtid(gtid);
-    #ifdef KMP_DEBUG
-        team_id       = team -> t.t_id;
-    #endif /* KMP_DEBUG */
-    /*    master_thread = team -> t.t_threads[0];*/
-    master_thread = this_thr -> th.th_team_master;
-    #ifdef KMP_DEBUG
-        if ( master_thread != team->t.t_threads[0] ) {
-            __kmp_print_structure();
-        }
-    #endif /* KMP_DEBUG */
-    KMP_DEBUG_ASSERT( master_thread == team->t.t_threads[0] );
-    KMP_MB();
-
-    /* verify state */
-    KMP_DEBUG_ASSERT( __kmp_threads && __kmp_threads[gtid] );
-    KMP_DEBUG_ASSERT( TCR_PTR(this_thr->th.th_team) );
-    KMP_DEBUG_ASSERT( TCR_PTR(this_thr->th.th_root) );
-    KMP_DEBUG_ASSERT( this_thr == team -> t.t_threads[tid] );
-
-    KA_TRACE( 10, ("__kmp_join_barrier: T#%d(%d:%d) arrived at join barrier\n",
-                   gtid, team_id, tid ));
-
-    #if OMP_30_ENABLED
-        if ( __kmp_tasking_mode == tskm_extra_barrier ) {
-            __kmp_tasking_barrier( team, this_thr, gtid );
-
-            KA_TRACE( 10, ("__kmp_join_barrier: T#%d(%d:%d) past taking barrier\n",
-                           gtid, team_id, tid ));
-        }
-        #ifdef KMP_DEBUG
-        if ( __kmp_tasking_mode != tskm_immediate_exec ) {
-            KA_TRACE( 20, ( "__kmp_join_barrier: T#%d, old team = %d, old task_team = %p, th_task_team = %p\n",
-                             __kmp_gtid_from_thread( this_thr ), team_id, team -> t.t_task_team,
-                             this_thr->th.th_task_team ) );
-            KMP_DEBUG_ASSERT( this_thr->th.th_task_team == team->t.t_task_team );
-        }
-        #endif /* KMP_DEBUG */
-    #endif /* OMP_30_ENABLED */
-
-    //
-    // Copy the blocktime info to the thread, where __kmp_wait_sleep()
-    // can access it when the team struct is not guaranteed to exist.
-    //
-    // Doing these loads causes a cache miss slows down EPCC parallel by 2x.
-    // As a workaround, we do not perform the copy if blocktime=infinite,
-    // since the values are not used by __kmp_wait_sleep() in that case.
-    //
-    if ( __kmp_dflt_blocktime != KMP_MAX_BLOCKTIME ) {
-        #if OMP_30_ENABLED
-            this_thr -> th.th_team_bt_intervals = team -> t.t_implicit_task_taskdata[tid].td_icvs.bt_intervals;
-            this_thr -> th.th_team_bt_set = team -> t.t_implicit_task_taskdata[tid].td_icvs.bt_set;
-        #else
-            this_thr -> th.th_team_bt_intervals = team -> t.t_set_bt_intervals[tid];
-            this_thr -> th.th_team_bt_set= team -> t.t_set_bt_set[tid];
-        #endif // OMP_30_ENABLED
-    }
-
-#if USE_ITT_BUILD
-    if ( __itt_sync_create_ptr || KMP_ITT_DEBUG )
-        __kmp_itt_barrier_starting( gtid, itt_sync_obj );
-#endif /* USE_ITT_BUILD */
-
-    if ( __kmp_barrier_gather_pattern[ bs_forkjoin_barrier ] == bp_linear_bar || __kmp_barrier_gather_branch_bits[ bs_forkjoin_barrier ] == 0 ) {
-        __kmp_linear_barrier_gather( bs_forkjoin_barrier, this_thr, gtid, tid, NULL
-                                     USE_ITT_BUILD_ARG( itt_sync_obj )
-                                     );
-    } else if ( __kmp_barrier_gather_pattern[ bs_forkjoin_barrier ] == bp_tree_bar ) {
-        __kmp_tree_barrier_gather( bs_forkjoin_barrier, this_thr, gtid, tid, NULL
-                                   USE_ITT_BUILD_ARG( itt_sync_obj )
-                                   );
-    } else {
-        __kmp_hyper_barrier_gather( bs_forkjoin_barrier, this_thr, gtid, tid, NULL
-                                    USE_ITT_BUILD_ARG( itt_sync_obj )
-                                    );
-    }; // if
-
-#if USE_ITT_BUILD
-    if ( __itt_sync_create_ptr || KMP_ITT_DEBUG )
-        __kmp_itt_barrier_middle( gtid, itt_sync_obj );
-#endif /* USE_ITT_BUILD */
-
-    //
-    // From this point on, the team data structure may be deallocated
-    // at any time by the master thread - it is unsafe to reference it
-    // in any of the worker threads.
-    //
-    // Any per-team data items that need to be referenced before the end
-    // of the barrier should be moved to the kmp_task_team_t structs.
-    //
-
-    #if OMP_30_ENABLED
-        if ( KMP_MASTER_TID( tid ) ) {
-            if ( __kmp_tasking_mode != tskm_immediate_exec ) {
-                // Master shouldn't call decrease_load().         // TODO: enable master threads.
-                // Master should have th_may_decrease_load == 0.  // TODO: enable master threads.
-                __kmp_task_team_wait( this_thr, team
-                                      USE_ITT_BUILD_ARG( itt_sync_obj )
-                                      );
-            }
-#if USE_ITT_BUILD && USE_ITT_NOTIFY
-            // Join barrier - report frame end
-            if( __itt_frame_submit_v3_ptr && __kmp_forkjoin_frames_mode ) {
-                kmp_uint64 tmp = __itt_get_timestamp();
-                ident_t * loc = team->t.t_ident;
-                switch( __kmp_forkjoin_frames_mode ) {
-                case 1:
-                  __kmp_itt_frame_submit( gtid, this_thr->th.th_frame_time, tmp, 0, loc );
-                  break;
-                case 2:
-                  __kmp_itt_frame_submit( gtid, this_thr->th.th_bar_arrive_time, tmp, 1, loc );
-                  break;
-                case 3:
-                  __kmp_itt_frame_submit( gtid, this_thr->th.th_frame_time, tmp, 0, loc );
-                  __kmp_itt_frame_submit( gtid, this_thr->th.th_bar_arrive_time, tmp, 1, loc );
-                  break;
-                }
-            }
-#endif /* USE_ITT_BUILD */
-        }
-    #endif /* OMP_30_ENABLED */
-
-    #if KMP_DEBUG
-        if( KMP_MASTER_TID( tid )) {
-            KA_TRACE( 15, ( "__kmp_join_barrier: T#%d(%d:%d) says all %d team threads arrived\n",
-                            gtid, team_id, tid, nproc ));
-        }
-    #endif /* KMP_DEBUG */
-
-    /* TODO now, mark worker threads as done so they may be disbanded */
-
-    KMP_MB();       /* Flush all pending memory write invalidates.  */
-    KA_TRACE( 10, ("__kmp_join_barrier: T#%d(%d:%d) leaving\n",
-                   gtid, team_id, tid ));
-}
-
-
-/* TODO release worker threads' fork barriers as we are ready instead of all at once */
-
-void
-__kmp_fork_barrier( int gtid, int tid )
-{
-    kmp_info_t *this_thr = __kmp_threads[ gtid ];
-    kmp_team_t *team     = ( tid == 0 ) ? this_thr -> th.th_team : NULL;
-#if USE_ITT_BUILD
-    void * itt_sync_obj = NULL;
-#endif /* USE_ITT_BUILD */
-
-    KA_TRACE( 10, ( "__kmp_fork_barrier: T#%d(%d:%d) has arrived\n",
-                    gtid, ( team != NULL ) ? team->t.t_id : -1, tid ));
-
-    /* th_team pointer only valid for master thread here */
-    if ( KMP_MASTER_TID( tid ) ) {
-
-#if USE_ITT_BUILD && USE_ITT_NOTIFY
-            if ( __itt_sync_create_ptr || KMP_ITT_DEBUG ) {
-                itt_sync_obj  = __kmp_itt_barrier_object( gtid, bs_forkjoin_barrier, 1 ); // create itt barrier object
-                //__kmp_itt_barrier_starting( gtid, itt_sync_obj );   // AC: no need to call prepare right before acquired
-                __kmp_itt_barrier_middle( gtid, itt_sync_obj );       // call acquired / releasing
-            }
-#endif /* USE_ITT_BUILD && USE_ITT_NOTIFY */
-
-#ifdef KMP_DEBUG
-
-        register kmp_info_t **other_threads = team -> t.t_threads;
-        register int          i;
-
-        /* verify state */
-        KMP_MB();
-
-        for( i = 1; i < team -> t.t_nproc ; i++ ) {
-            KA_TRACE( 500, ( "__kmp_fork_barrier: T#%d(%d:0) checking T#%d(%d:%d) fork "
-                             "go == %u.\n",
-                             gtid, team->t.t_id, other_threads[i]->th.th_info.ds.ds_gtid,
-                             team->t.t_id, other_threads[i]->th.th_info.ds.ds_tid,
-                             other_threads[i]->th.th_bar[ bs_forkjoin_barrier ].bb.b_go ) );
-
-            KMP_DEBUG_ASSERT( ( TCR_4( other_threads[i]->th.th_bar[bs_forkjoin_barrier].bb.b_go )
-                                & ~(KMP_BARRIER_SLEEP_STATE) )
-                               == KMP_INIT_BARRIER_STATE );
-            KMP_DEBUG_ASSERT( other_threads[i]->th.th_team == team );
-
-        }
-#endif
-
-#if OMP_30_ENABLED
-        if ( __kmp_tasking_mode != tskm_immediate_exec ) {
-            __kmp_task_team_setup( this_thr, team );
-        }
-#endif /* OMP_30_ENABLED */
-
-        //
-        // The master thread may have changed its blocktime between the
-        // join barrier and the fork barrier.
-        //
-        // Copy the blocktime info to the thread, where __kmp_wait_sleep()
-        // can access it when the team struct is not guaranteed to exist.
-        //
-        // See the note about the corresponding code in __kmp_join_barrier()
-        // being performance-critical.
-        //
-        if ( __kmp_dflt_blocktime != KMP_MAX_BLOCKTIME ) {
-#if OMP_30_ENABLED
-            this_thr -> th.th_team_bt_intervals = team -> t.t_implicit_task_taskdata[tid].td_icvs.bt_intervals;
-            this_thr -> th.th_team_bt_set = team -> t.t_implicit_task_taskdata[tid].td_icvs.bt_set;
-#else
-            this_thr -> th.th_team_bt_intervals = team -> t.t_set_bt_intervals[tid];
-            this_thr -> th.th_team_bt_set= team -> t.t_set_bt_set[tid];
-#endif // OMP_30_ENABLED
-        }
-    } // master
-
-    if ( __kmp_barrier_release_pattern[ bs_forkjoin_barrier ] == bp_linear_bar || __kmp_barrier_release_branch_bits[ bs_forkjoin_barrier ] == 0 ) {
-        __kmp_linear_barrier_release( bs_forkjoin_barrier, this_thr, gtid, tid, TRUE
-                                      USE_ITT_BUILD_ARG( itt_sync_obj )
-                                      );
-    } else if ( __kmp_barrier_release_pattern[ bs_forkjoin_barrier ] == bp_tree_bar ) {
-        __kmp_tree_barrier_release( bs_forkjoin_barrier, this_thr, gtid, tid, TRUE
-                                    USE_ITT_BUILD_ARG( itt_sync_obj )
-                                    );
-    } else {
-        __kmp_hyper_barrier_release( bs_forkjoin_barrier, this_thr, gtid, tid, TRUE
-                                     USE_ITT_BUILD_ARG( itt_sync_obj )
-                                     );
-    }; // if
-
-    //
-    // early exit for reaping threads releasing forkjoin barrier
-    //
-    if ( TCR_4(__kmp_global.g.g_done) ) {
-
-#if OMP_30_ENABLED
-        if ( this_thr->th.th_task_team != NULL ) {
-            if ( KMP_MASTER_TID( tid ) ) {
-                TCW_PTR(this_thr->th.th_task_team, NULL);
-            }
-            else {
-                __kmp_unref_task_team( this_thr->th.th_task_team, this_thr );
-            }
-        }
-#endif /* OMP_30_ENABLED */
-
-#if USE_ITT_BUILD && USE_ITT_NOTIFY
-        if ( __itt_sync_create_ptr || KMP_ITT_DEBUG ) {
-            if ( !KMP_MASTER_TID( tid ) ) {
-                itt_sync_obj  = __kmp_itt_barrier_object( gtid, bs_forkjoin_barrier );
-                if ( itt_sync_obj )
-                    __kmp_itt_barrier_finished( gtid, itt_sync_obj );
-            }
-        }
-#endif /* USE_ITT_BUILD && USE_ITT_NOTIFY */
-        KA_TRACE( 10, ( "__kmp_fork_barrier: T#%d is leaving early\n", gtid ));
-        return;
-    }
-
-    //
-    // We can now assume that a valid team structure has been allocated
-    // by the master and propagated to all worker threads.
-    //
-    // The current thread, however, may not be part of the team, so we can't
-    // blindly assume that the team pointer is non-null.
-    //
-    team = (kmp_team_t *)TCR_PTR(this_thr->th.th_team);
-    KMP_DEBUG_ASSERT( team != NULL );
-    tid = __kmp_tid_from_gtid( gtid );
-
-#if OMP_30_ENABLED
-
-# if KMP_BARRIER_ICV_PULL
-    // Master thread's copy of the ICVs was set up on the implicit taskdata in __kmp_reinitialize_team.
-    // __kmp_fork_call() assumes the master thread's implicit task has this data before this function is called.
-    // We cannot modify __kmp_fork_call() to look at the fixed ICVs in the master's thread struct, because it is
-    // not always the case that the threads arrays have been allocated when __kmp_fork_call() is executed.
-    if (! KMP_MASTER_TID( tid ) ) {  // master thread already has ICVs
-        // Copy the initial ICVs from the master's thread struct to the implicit task for this tid.
-        KA_TRACE( 10, ( "__kmp_fork_barrier: T#%d(%d) is PULLing ICVs\n", gtid, tid ));
-        load_icvs(&team->t.t_threads[0]->th.th_fixed_icvs);
-        __kmp_init_implicit_task( team->t.t_ident, team->t.t_threads[tid], team, tid, FALSE );
-        store_icvs(&team->t.t_implicit_task_taskdata[tid].td_icvs, &team->t.t_threads[0]->th.th_fixed_icvs);
-        sync_icvs();
-    }
-# endif // KMP_BARRIER_ICV_PULL
-
-    if ( __kmp_tasking_mode != tskm_immediate_exec ) {
-        __kmp_task_team_sync( this_thr, team );
-    }
-
-#endif /* OMP_30_ENABLED */
-
-#if OMP_40_ENABLED && KMP_AFFINITY_SUPPORTED
-    kmp_proc_bind_t proc_bind = team->t.t_proc_bind;
-    if ( proc_bind == proc_bind_intel ) {
-#endif
-#if KMP_MIC
-        //
-        // Call dynamic affinity settings
-        //
-        if( __kmp_affinity_type == affinity_balanced && team->t.t_size_changed ) {
-            __kmp_balanced_affinity( tid, team->t.t_nproc );
-        }
-#endif
-#if OMP_40_ENABLED && KMP_AFFINITY_SUPPORTED
-    }
-    else if ( ( proc_bind != proc_bind_false )
-              && ( proc_bind != proc_bind_disabled )) {
-        if ( this_thr->th.th_new_place == this_thr->th.th_current_place ) {
-            KA_TRACE( 100, ( "__kmp_fork_barrier: T#%d already in correct place %d\n",
-                             __kmp_gtid_from_thread( this_thr ), this_thr->th.th_current_place ) );
-        }
-        else {
-            __kmp_affinity_set_place( gtid );
-        }
-    }
-#endif
-
-#if USE_ITT_BUILD && USE_ITT_NOTIFY
-    if ( __itt_sync_create_ptr || KMP_ITT_DEBUG ) {
-        if ( !KMP_MASTER_TID( tid ) ) {
-            itt_sync_obj  = __kmp_itt_barrier_object( gtid, bs_forkjoin_barrier ); // get correct barrier object
-            __kmp_itt_barrier_finished( gtid, itt_sync_obj );   // workers call acquired
-        }                                                                          // (prepare called inside barrier_release)
-    }
-#endif /* USE_ITT_BUILD && USE_ITT_NOTIFY */
-    KA_TRACE( 10, ( "__kmp_fork_barrier: T#%d(%d:%d) is leaving\n",
-      gtid, team->t.t_id, tid ));
-}
-
 
 /* ------------------------------------------------------------------------ */
-/* ------------------------------------------------------------------------ */
 
 void *
 __kmp_launch_thread( kmp_info_t *this_thr )
